package benefactorkindboxreqservice

import (
	"context"

	param "git.gocasts.ir/ebhomengo/niki/param/benefactor/kind_box_req"
	response "git.gocasts.ir/ebhomengo/niki/pkg/response_builder"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
)

func (s Service) Get(ctx context.Context, req param.KindBoxReqGetRequest) (param.KindBoxReqGetResponse, error) {
	const op = "userkindboxreqservice.Get"
	if fieldErrors, vErr := s.vld.ValidateGetRequest(ctx, req); vErr != nil {
		return param.KindBoxReqGetResponse{FieldErrors: fieldErrors}, richerror.New(op).WithErr(vErr)
	}

	kindBoxReq, err := s.repo.GetKindBoxReqByID(ctx, req.KindBoxReqID)
	if err != nil {
		return param.KindBoxReqGetResponse{}, richerror.New(op).WithErr(err)
	}

	return param.KindBoxReqGetResponse{Data: param.Data{
		ID:                 kindBoxReq.ID,
		BenefactorID:       kindBoxReq.BenefactorID,
		KindBoxType:        kindBoxReq.KindBoxType,
		CountRequested:     kindBoxReq.CountRequested,
		CountAccepted:      kindBoxReq.CountAccepted,
		Description:        kindBoxReq.Description,
		Status:             kindBoxReq.Status,
		DeliverReferTimeID: kindBoxReq.DeliverReferTimeID,
		DeliverReferDate:   kindBoxReq.DeliverReferDate,
		DeliverAddressID:   kindBoxReq.DeliverAddressID,
		SenderAgentID:      kindBoxReq.SenderAgentID,
		DeliveredAt:        response.GetNullDate(kindBoxReq.DeliveredAt),
	}}, nil
}
